Monkey and Banana
Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 7416 Accepted Submission(s): 3813
Problem Description
A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with some blocks. If the monkey is clever enough, it shall be able to reach the banana by placing one block on the top another to build a tower and climb up to get its favorite food.
The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions of the base and the other dimension was the height.
They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both strictly smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn't be stacked.
Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks.
The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions of the base and the other dimension was the height.
They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both strictly smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn't be stacked.
Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks.
Input
The input file will contain one or more test cases. The first line of each test case contains an integer n,
representing the number of different blocks in the following data set. The maximum value for n is 30.
Each of the next n lines contains three integers representing the values xi, yi and zi.
Input is terminated by a value of zero (0) for n.
representing the number of different blocks in the following data set. The maximum value for n is 30.
Each of the next n lines contains three integers representing the values xi, yi and zi.
Input is terminated by a value of zero (0) for n.
Output
For each test case, print one line containing the case number (they are numbered sequentially starting from 1) and the height of the tallest possible tower in the format "Case case: maximum height = height".
Sample Input
1
10 20 30
2
6 8 10
5 5 5
7
1 1 1
2 2 2
3 3 3
4 4 4
5 5 5
6 6 6
7 7 7
5
31 41 59
26 53 58
97 93 23
84 62 64
33 83 27
0
Sample Output
Case 1: maximum height = 40
Case 2: maximum height = 21
Case 3: maximum height = 28
Case 4: maximum height = 342
题意:
给出 n (n <= 30),代表给出 n 种长方体,给出每个长方体的三个长度,可以任意摆放任意使用多个,问叠放起来的最高高度是多少,输出最高的高度。底部的两边必须严格小于下面的底部才能往上叠放。
思路:
DP。类似于矩形嵌套的变形。找最长上升子序列。将一个长方体拆开六种来判断即可,dp[ i ] 表示到第 i 个长方体的最高高度是多少。
AC:
#include <cstdio> #include <cstring> #include <algorithm> using namespace std; typedef struct { int l, w, h; } node; node num[200]; int ans, dp[200]; bool cmp (node a, node b) { if (a.l != b.l) return a.l > b.l; if (a.w != b.w) return a.w > b.w; return a.h > b.h; } int main() { int n, t = 0; while (~scanf("%d", &n) && n) { ans = 0; memset(dp, 0, sizeof(dp)); while (n--) { int a, b, c; scanf("%d%d%d", &a, &b, &c); num[ans].l = a, num[ans].w = b, num[ans++].h = c; num[ans].l = a, num[ans].w = c, num[ans++].h = b; num[ans].l = b, num[ans].w = a, num[ans++].h = c; num[ans].l = b, num[ans].w = c, num[ans++].h = a; num[ans].l = c, num[ans].w = a, num[ans++].h = b; num[ans].l = c, num[ans].w = b, num[ans++].h = a; } sort(num, num + ans, cmp); int max_high = 0; dp[0] = num[0].h; for (int i = 1; i < ans; ++i) { int max_temp = 0; for (int j = 0; j < i; ++j) { if (num[j].l > num[i].l && num[j].w > num[i].w) max_temp = max(max_temp, dp[j]); } dp[i] = max_temp + num[i].h; max_high = max(max_high, dp[i]); } printf("Case %d: maximum height = %d\n", ++t, max_high); } return 0; }
相关推荐
最基础的DP题目解题报告,适合初学者!动态规划(DP1) ...解题报告: 1001 计算直线的交点数 1002 FatMouse's Speed1003 Common ... 1006 免费馅饼 1007 Humble Numbers1008 Monkey and Banana 1009 龟兔赛跑 1010 数塔
9. **Monkey And Banana**(题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1069) 类似于最大递增子序列和,但要考虑猴子跳跃的限制。状态方程为:`f[j]=max{f[i]}+v[j]`,其中`0,`w[i][j]`,`h[i][j]`。 ...
**1093 Monkey and Banana** - 动物行为模拟 DP在动物行为研究中,可以模拟动物获取食物的最佳路径。 #### 24. **1094 Matrix Chain Multiplication** - 矩阵连乘优化 矩阵运算中,DP可以优化矩阵乘法顺序,减少...
1093题“Monkey and Banana”和1094题“Matrix Chain Multiplication”是动态规划的经典实例,前者可能是关于最短路径或状态转移,后者则涉及矩阵乘法的优化。同样,1100题“Mondriaan's Dream”和1107题“FatMouse ...
23. **1093 - Monkey and Banana**:猴子取香蕉的问题,涉及到策略制定。 24. **1094 - Matrix Chain Multiplication**:矩阵链乘法问题。 25. **1536 - Labyrinth**:迷宫寻路问题。 26. **1100 - Mondriaans Dream...
1093 Monkey and Banana 简单题 1094 Matrix Chain Multiplication 简单题 1536 Labyrinth 简单题 1100 Mondriaan s Dream 简单题,DP可以过,不过据说有复杂的组合公式 1103 Hike on a Graph 简单题 1134 ...
1093 Monkey and Banana 简单题 1094 Matrix Chain Multiplication 简单题 1536 Labyrinth 简单题 1100 Mondriaan s Dream 简单题,DP可以过,不过据说有复杂的组合公式 1103 Hike on a Graph 简单题 1134 ...
23. **1093 Monkey and Banana** - **背景**: 猴子摘香蕉问题。 - **解法**: 动态规划找到最优路径。 24. **1094 Matrix Chain Multiplication** - **背景**: 矩阵链乘积的最优化问题。 - **解法**: 动态规划...